<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMiniRulesPriceMessages ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfMiniRulesPriceMessages extends AbstractStructArrayBase
{
    /**
     * The MiniRulesPriceMessages
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgMiniRulesPriceMessages[]
     */
    public $MiniRulesPriceMessages;
    /**
     * Constructor method for ArrayOfMiniRulesPriceMessages
     * @uses DgArrayOfMiniRulesPriceMessages::setMiniRulesPriceMessages()
     * @param \dgsoft\StructType\DgMiniRulesPriceMessages[] $miniRulesPriceMessages
     */
    public function __construct(array $miniRulesPriceMessages = array())
    {
        $this
            ->setMiniRulesPriceMessages($miniRulesPriceMessages);
    }
    /**
     * Get MiniRulesPriceMessages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgMiniRulesPriceMessages[]|null
     */
    public function getMiniRulesPriceMessages()
    {
        return isset($this->MiniRulesPriceMessages) ? $this->MiniRulesPriceMessages : null;
    }
    /**
     * Set MiniRulesPriceMessages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgMiniRulesPriceMessages[] $miniRulesPriceMessages
     * @return \dgsoft\ArrayType\DgArrayOfMiniRulesPriceMessages
     */
    public function setMiniRulesPriceMessages(array $miniRulesPriceMessages = array())
    {
        foreach ($miniRulesPriceMessages as $arrayOfMiniRulesPriceMessagesMiniRulesPriceMessagesItem) {
            // validation for constraint: itemType
            if (!$arrayOfMiniRulesPriceMessagesMiniRulesPriceMessagesItem instanceof \dgsoft\StructType\DgMiniRulesPriceMessages) {
                throw new \InvalidArgumentException(sprintf('The MiniRulesPriceMessages property can only contain items of \dgsoft\StructType\DgMiniRulesPriceMessages, "%s" given', is_object($arrayOfMiniRulesPriceMessagesMiniRulesPriceMessagesItem) ? get_class($arrayOfMiniRulesPriceMessagesMiniRulesPriceMessagesItem) : gettype($arrayOfMiniRulesPriceMessagesMiniRulesPriceMessagesItem)), __LINE__);
            }
        }
        if (is_null($miniRulesPriceMessages) || (is_array($miniRulesPriceMessages) && empty($miniRulesPriceMessages))) {
            unset($this->MiniRulesPriceMessages);
        } else {
            $this->MiniRulesPriceMessages = $miniRulesPriceMessages;
        }
        return $this;
    }
    /**
     * Add item to MiniRulesPriceMessages value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgMiniRulesPriceMessages $item
     * @return \dgsoft\ArrayType\DgArrayOfMiniRulesPriceMessages
     */
    public function addToMiniRulesPriceMessages(\dgsoft\StructType\DgMiniRulesPriceMessages $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgMiniRulesPriceMessages) {
            throw new \InvalidArgumentException(sprintf('The MiniRulesPriceMessages property can only contain items of \dgsoft\StructType\DgMiniRulesPriceMessages, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->MiniRulesPriceMessages[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgMiniRulesPriceMessages|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgMiniRulesPriceMessages|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgMiniRulesPriceMessages|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgMiniRulesPriceMessages|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgMiniRulesPriceMessages|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MiniRulesPriceMessages
     */
    public function getAttributeName()
    {
        return 'MiniRulesPriceMessages';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfMiniRulesPriceMessages
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
